#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>

// konwersje
char conva[4][100]; int wsp[4]; char convb[4][100];
bool o[4];

int p;

float conv(float x, char *a, char *b)
{
  if(strcmp(a, b) == 0) return x;
  else
  {
    int i = 0;
    float tmp;
    while(i < p)
    {
      if(strcmp(conva[i], a) == 0 && !o[i])
      {
        o[i] = true;
        tmp = conv(x * wsp[i], convb[i], b);
	if(tmp != -1) return tmp;
      } else if(strcmp(convb[i], a) == 0 && !o[i])
      {
        o[i] = true;
	tmp = conv(x / wsp[i], conva[i], b);
	if(tmp != -1) return tmp;
      }
      i++;
    }
   return -1;
  }
}

float jconv(float x, char *a, char *b)
{
  if(strcmp(a, b) == 0) return x;
  for(int i = 0;i < p;i++) o[i] = false;
  return conv(x, a, b);
}

struct sztaba
{
  float x;
  char j[11];
};

int cmp(const void* a, const void* b)
{
  sztaba *as = *(sztaba**) a;
  sztaba *bs = *(sztaba**) b;

  if(strcmp(as->j, bs->j) == 0)
  { 
    if(as->x > bs->x) return 1; else return -1;
    return 0;
  }
  
  float t = jconv(as->x, as->j, bs->j);
  if(t > bs->x) return 1;
  if(t < bs->x) return -1;
  return 0;
}

/*
class V
{
  public:
  
    int x;
    char *jedn;
    V *p, *l, *r;

    V(int _x, char *_jedn)
    {
      x = _x;
      jedn = _jedn;
      p = NULL;
      l = NULL;
      r = NULL;
    }
};
*/

sztaba* tab[100001];

int main()
{
  int t;
  scanf("%d", &t);
  while(t--)
  {
    scanf("%d", &p);
    for(int i = 0;i < p;i++)
    {
      char tmp[2];
      scanf("%s%s%s%d%s", tmp, conva[i], tmp, &wsp[i], convb[i]);
    }
    
    int c, i = 0;
    scanf("%d", &c);
    
    while(i < c)
    {
      sztaba *s = new sztaba;
      scanf("%f%s", &s->x, s->j);
      tab[i] = s;
      i++;
    }
    
    qsort(tab, c, sizeof(void *), &cmp);

#ifdef DEBUG    
    for(int i = 0;i < c;i++)
    {
      printf("%f %s\n", tab[i]->x, tab[i]->j);
    }
#endif
    
    int qq, cur = 0;
    scanf("%d", &qq);
    while(cur < qq)
    {
      sztaba *act = new sztaba;
      scanf("%f%s", &act->x, act->j);
      
      int p, q, f;
      p = 0; q = c - 1;
      f = q / 2;
      
      while(cmp(&tab[f], &act) != 0 && p != f)
      {
        int c = cmp(&tab[f], &act);
#ifdef DEBUG
	printf("%d - %d - %d\n", p, f, q);
#endif

	if(c <= 0)
	{
	  p = f;
	} else {
	  q = f;
	}
        f = p + ((q - p) / 2);
      }
      
      if(f != c - 1)
      {
        float l = jconv(tab[f]->x, tab[f]->j, act->j);
	float r = jconv(tab[f+1]->x, tab[f+1]->j, act->j);
#ifdef DEBUG
	printf("l act r: %d %d %d\n", l, act->x, r);
#endif
	if(fabs(act->x - l) > fabs(act->x - r)) f++;
      }
      printf("%.0f %s\n", tab[f]->x, tab[f]->j);
      cur++;
    }
    
    for(int i = 0;i < c;i++) delete tab[i];
  }
  
  
  return 0;
}
